

//CHANGE NUMBERS OF SENSORS
const unsigned int nbHands=2;
const unsigned int nbAnalogFingers=2;
const unsigned int nbDigitalFingers=2;
////



unsigned int analogFingers[nbHands][nbAnalogFingers];
unsigned int digitalFingers[nbHands][nbDigitalFingers];
unsigned int analogSensors[nbHands][nbAnalogFingers];
unsigned int digitalSensors[nbHands][nbDigitalFingers];

const unsigned int totalNbFingers=nbHands*(nbAnalogFingers+nbDigitalFingers);

//state: 0:released, 1:hitting, 2:pressing
unsigned int fingersStates[totalNbFingers]; 
unsigned int fingersMaxValues[totalNbFingers]; 
unsigned long fingersTimes[totalNbFingers];

unsigned int outputValue=0;
bool outputPressure=true;


//CHANGE THRESHOLDS
unsigned int hitValueThreshold=40;
unsigned int hitTimeThreshold=5000; //microseconds
unsigned int releaseThreshold=10;
////


unsigned long elapsedTime=0;


void setup() {
    //SET BAUDRATE
    Serial.begin(9600);
    ////


    //SET SENSORS AND FINGERS IDs

    //left hand
    analogSensors[0][0]=0;
    analogSensors[0][1]=1;
    analogFingers[0][0]=1;
    analogFingers[0][1]=2;

    //right hand
    analogSensors[1][0]=2;
    analogSensors[1][1]=3;
    analogFingers[1][0]=1;
    analogFingers[1][1]=2;

    ////



    for(unsigned int f=0; f<totalNbFingers; ++f) {
        fingersStates[f]=0;
        fingersTimes[f]=0;
    }
}

void loop() {
    for(int h=0; h<nbHands; h++) {
        for(int af=0; af<nbAnalogFingers; af++) {

            outputValue=1023 - analogRead(analogFingers[h][af]);

            //test state
            switch(fingersStates[analogFingers[h][af]]) {
                case 0: { //released
                    if(outputValue>releaseThreshold) {
                        if(outputValue>hitValueThreshold) { //hit
                            fingersStates[analogFingers[h][af]]=2;
                            Serial.print((h+1)*1000000
                                            +(analogFingers[h][af]+1)*100000
                                            +20000
                                            +outputValue, 
                                        DEC);
                        }
                        else { //waiting hitting
                            fingersStates[analogFingers[h][af]]=1;
                            fingersTimes[analogFingers[h][af]]=micros();
                            fingersMaxValues[analogFingers[h][af]]=outputValue;
                        }
                    }
                }break;
                case 1: { //hitting
                    elapsedTime = micros()-fingersTimes[analogFingers[h][af]];
                    if(elapsedTime>hitTimeThreshold) {
                        if(outputValue>hitValueThreshold) { //hit
                            Serial.print((h+1)*1000000
                                            +(analogFingers[h][af]+1)*100000
                                            +20000
                                            +outputValue, 
                                        DEC);
                        }
                        fingersStates[analogFingers[h][af]]=2;
                    }
                    else {
                        if(outputValue >
                                fingersMaxValues[analogFingers[h][af]]) {
                            fingersMaxValues[analogFingers[h][af]]=outputValue;
                        }
                    }
                }break;
                case 2: { //pressing


                    if(outputPressure) { //pressure
                        Serial.print((h+1)*1000000
                                        +(analogFingers[h][af]+1)*100000
                                        +30000
                                        +outputValue, 
                                    DEC);
                        outputPressure=!outputPressure;
                    }

                    if(outputValue<releaseThreshold) { //release
                        fingersStates[analogFingers[h][af]]=0;
                        fingersMaxValues[analogFingers[h][af]]=0;
                        Serial.print((h+1)*1000000
                                        +(analogFingers[h][af]+1)*100000
                                        +10000
                                        +outputValue, 
                                    DEC);
                    }

                }break;
            }
        }

        //TODO digital fingers
    }
}
