/***************************************************************************
 *  DrileDisplay.hpp
 *  Part of Drile
 *  2010-  Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _DISPLAY_WINDOW_H
#define _DISPLAY_WINDOW_H

#include <OpenSG/OSGGLUT.h>
#include <OpenSG/OSGConfig.h>
#include <OpenSG/OSGClusterServer.h>
#include <OpenSG/OSGGLUTWindow.h>
#include <OpenSG/OSGRenderAction.h>
#include <OpenSG/OSGPassiveWindow.h>
#include <sstream>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/extensions/Xinerama.h>

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <FL/x.H>
#include <FL/x.H>

class DrileDisplay : public Fl_Gl_Window {
  public:
        DrileDisplay(int ,int ,const char*);
        ~DrileDisplay();
        void draw();
        void toggleFullscreen();    
        int handle(int);
        void init(std::string name="camera_1", int port=7010);
        void resize(int,int,int,int);

        static void idle(void* pnt);

  private:
        bool m_fullscreen;
        bool m_displayTooltip;
        OSG::PassiveWindowRecPtr m_osgWin;
        OSG::RenderActionRefPtr m_ract;
        OSG::ClusterServer* m_server;

        std::string m_name;
        int m_port;
};


#endif
