/***************************************************************************
 *  Event.hpp
 *  Part of Drile
 *  2010-  Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _EVENT_H
#define _EVENT_H

#include <iostream>
#include <cstring>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <map>

#include "devices/MappingID.hpp"

class HllElement;

enum EVENT_TYPE{EVENT_NODE, EVENT_TREE, EVENT_PIIVERT, EVENT_CAMERA, 
                EVENT_MAPPING};

struct Event {
    Event():offset(0){}
    EVENT_TYPE type;
    int parameter;
    timeval time;
    unsigned long timeD;
    double offset;
    int node;
    int piivert;
    int camera;
    int hand;
    int finger;
    HllElement* nodePtr;
    MappingID mapping;
    static const unsigned int nbValues=32;
    double values[nbValues];
};

#endif
