/***************************************************************************
 *  Compressor.hpp
 *  Part of Drile
 *
 *  2010- Florent Berthaut
 *  hitmuri.net 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _Compressor_H
#define _Compressor_H

#include <stdio.h>
#include <stdlib.h>
#include <vector>

#include <jack/jack.h>
#include <jack/ringbuffer.h>
#include <jack/types.h>

#include "util/db.h"
#include "util/rms.h"

class Compressor  {
    public:
        Compressor(const int& );
        ~Compressor();
        void process(std::vector<double>&, std::vector<double>&, 
                        std::vector<double>&);

    private:
        int m_sampleRate;

        double m_attack;
        double m_release;
        double m_threshold;
        double m_ratio;
        double m_makeupGain;
        double m_knee;
        double m_chainBal;

        double        m_amp;
        double *      m_as;
        unsigned int m_count;
        double        m_env;
        double        m_gain;
        double        m_gainT;
        rms_env *    m_rms;
        double        m_sum;
};

#endif

