/***************************************************************************
 *  Filter.hpp
 *  Part of Drile
 *  2010-  Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _FILTER_H
#define _FILTER_H

#include "util/iir.h"
#include <jack/jack.h>
#include <jack/ringbuffer.h>
#include <jack/types.h>
#include <vector>

class Filter  {
    public:
        Filter(double frequency, double sampleRate);
        ~Filter();
        void process(std::vector<double>&);

    private:
        double m_frequency;
        double m_sampleRate;
        double m_cutoff;
        double m_stages;
        iirf_t* m_iirf;
        iir_stage_t* m_gt;

};

#endif

