/***************************************************************************
 *  HllLeaf.cpp
 *  Part of Drile
 *  2010- Florent Berthaut
 *  hitmuri.net 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "HllLeaf.hpp"
#include "AudioManager.hpp"

using namespace std;

HllLeaf::HllLeaf(const int& id, const int& sampleRate, 
                    const int& bufferSize): HllElement(id), 
                    m_sampleRate(sampleRate), m_bufferSize(bufferSize), 
                    m_compressed(false), m_compressing(false) {
    m_spectrumBuffer.resize(m_bufferSize,0);
    m_analysisBuffer.resize(m_bufferSize,0);
    m_fadeStep = 1.0/(double)m_bufferSize;
}

HllLeaf::~HllLeaf(){}

void HllLeaf::process(const double &timeDiff,
                std::vector<std::vector<double> >& tempBuffer, 
                std::vector<std::vector<double> >& outputBuffer, 
                std::vector<Event>& outputEvents) {

    HllElement::process(timeDiff, tempBuffer, outputBuffer, outputEvents);
}


