/***************************************************************************
 *  HllLeaf.hpp
 *  Part of Drile
 *  2010-  Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _HLL_LEAF_H
#define _HLL_LEAF_H

#include "HllElement.hpp"

class HllLeaf: public HllElement {
    public:
        HllLeaf(const int& id, const int& sampleRate, const int& bufferSize);
        ~HllLeaf();

        virtual void duplicate(std::vector<HllElement*>& createElements, 
                        int& elementsIdCounter)=0;

        virtual void process(const double&, std::vector<std::vector<double> >&, 
                std::vector<std::vector<double> >&, std::vector<Event>&);

        inline void loopPlay(timeval&){}
        inline virtual void loopStop(const int& param=-1){}

        inline unsigned int getNbChildren(){return 0;}
        inline HllElement* getChild(unsigned int c){return NULL;}

    protected:

        int m_sampleRate;
        int m_bufferSize;
        double m_fadeStep;

        std::vector<double> m_spectrumBuffer;
        std::vector<double> m_analysisBuffer;

        bool m_compressed;
        bool m_compressing;
};



#endif
