/***************************************************************************
 *  SasNode.hpp
 *  Part of Drile
 *  2010- Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
/*
#ifndef _SAS_NODE_H
#define _SAS_NODE_H

#include <iostream>
#include <cstring>
#include <cmath>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <map>

#include <sndfile.h>
#include <samplerate.h>

#include "Node.hpp"
#include "Sample.hpp"

#include "util/sas/sas.h"

#define ENVELOPE_SIZE 20
#define ENVELOPE_BASE (SAS_MAX_AUDIBLE_FREQUENCY / ENVELOPE_SIZE)

struct SasNodeEvent
{
    float fade;
    float fadeStep;

};

struct source_data_s {
  sas_source_t source;
  char * filename;
  sas_file_t file;
  int number_of_frames;
  sas_frame_t frame;
  struct sas_position_s pos;
};

class SasNode: public Node
{
    public:
        SasNode(const int&);
        SasNode(const int&,const SasNode&);
        ~SasNode();
        void parse(xmlNodePtr);

        void load();
        void unload();

        void setParameter(const NODE_PARAMETER&, const std::vector<float>& values, bool valueFromLoop=false);

        void process(timeval&, std::vector<std::vector<float> >&, std::vector<std::vector<float> >&);
        void analyse(timeval&, std::vector<AudioEvent>&);

    private:
    
        void processFadedEffects(std::vector<std::vector<float> >&, float);

        Sample* m_sample;

        float m_volume;
        int m_polyphony;

        int m_grainSize; // grain size
        float m_grainFadeStep;
        float m_resoStep; //grain fade out
        float m_grainStep; //speed
        int m_grainDistance; //distance between grains
        

        timeval m_lastParameterFadeTime;

        std::vector<float> m_analysisBuffer;
        std::vector<float> m_spectrumBuffer;
        int* m_barkBands;
        static const int NB_BARK_BANDS=25;

        //events
        std::vector<SasNodeEvent> m_contEvents;
        std::vector<SasNodeEvent> m_instEvents;

        double m_amp;
        double m_freq;
        double m_color[ENVELOPE_SIZE];
        double m_warp[ENVELOPE_SIZE];
        double m_warpIdentity[ENVELOPE_SIZE];

        source_data_s m_sourceData;
        sas_synthesizer_t m_synth;
        sas_envelope_t m_warpEnvelope;
        sas_envelope_t m_colorEnvelope;
        double m_outputBuffer[2*SAS_SAMPLES];
        int m_counter;
};



#endif

*/
