/***************************************************************************
 *  Reverb.cpp
 *  Uses gverb : Copyright (C) 1999 Juhana Sadeharju kouhia at nic.funet.fi
 *
 *  Part of Hitpad
 *  2012- Florent Berthaut
 *  hitmuri.net 
 *
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Reverb.hpp"

using namespace std;

Reverb::Reverb(const int& sampleRate): m_sampleRate(sampleRate) {
    m_gverbL=gverb_new(sampleRate, 50, 50, 0.5, 0, 1, 1, 0.1, 0.1);
    m_gverbR=gverb_new(sampleRate, 50, 50, 0.5, 0, 1, 1, 0.1, 0.1);
}

Reverb::~Reverb() {
    gverb_free(m_gverbL);
    gverb_free(m_gverbR);
}

void Reverb::process(vector<double>& leftBuffer, vector<double>& rightBuffer) {
    float ll, lr, rl, rr;
    for(unsigned int f=0; f<leftBuffer.size(); ++f) {
        gverb_do(m_gverbL, leftBuffer[f], &ll, &lr);
        gverb_do(m_gverbR, rightBuffer[f], &rl, &rr);
        leftBuffer[f]+=ll/2.0+rl/2.0;
        rightBuffer[f]+=rl/2.0+rr/2.0;
    }
}


