/***************************************************************************
 *  Reverb.hpp
 *  Part of Hitpad
 *  2012- Florent Berthaut
 *  hitmuri.net 
 *
 *  Uses mostly code from Steve Harris SC3 LADSPA plugin
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _Reverb_H
#define _Reverb_H

#include <stdio.h>
#include <stdlib.h>
#include <vector>

#include <jack/jack.h>
#include <jack/ringbuffer.h>
#include <jack/types.h>

#include "util/gverb.h"
#include "util/gverbdsp.h"

class Reverb  {
	public:
		Reverb(const int&);
		~Reverb();
		void process(std::vector<double>& leftBuffer, 
                        std::vector<double>& rightBuffer);

	private:
        int m_sampleRate;
        ty_gverb* m_gverbL;
        ty_gverb* m_gverbR;

};

#endif

