/***************************************************************************
 *  Device.cpp
 *  Part of Drile
 *  2010- Florent Berthaut
 *  hitmuri.net 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "Device.hpp"
#include "../Drile.hpp"

using namespace std;

Device::Device(const int& id): m_id(id)
{
    ostringstream oss;
    oss<<m_id;
    m_name = "Device"+oss.str();

}

Device::~Device()
{

}

void Device::update(vector<Event>& audioEvents, vector<Event>& envEvents) {
    vector<Mapping*>::iterator itMap = m_mappings[0].begin();
    for(; itMap!=m_mappings[0].end(); ++itMap) {
        (*itMap)->update(audioEvents, envEvents);
    } 
    itMap = m_mappings[1].begin();
    for(; itMap!=m_mappings[1].end(); ++itMap) {
        (*itMap)->update(audioEvents, envEvents);
    } 
}

