/***************************************************************************
 *            Device.hpp
 *            Part of Drile
 *
 *  2010  Tardigrade Inc.
 *  http://tardigrade-inc.com 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _DEVICE_H
#define _DEVICE_H

#include <iostream>
#include <cstring>
#include <cmath>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <map>
#include <libxml/parser.h>
#include <libxml/tree.h>

#include "Mapping.hpp"

class Device
{
    public:
        Device(const int&);
        ~Device();
        virtual void parse(xmlNodePtr)=0;
        inline void setName(const std::string& name){ m_name=name; }
        virtual void getMappingsIDs(std::vector<MappingID>&)=0;
        void update(std::vector<Event>&, std::vector<Event>&);
    
    protected:
        std::string m_name;
        int m_id;

        std::vector<Mapping*> m_mappings[2];

        std::vector<Mapping*> m_outputMappings;

};



#endif
