/***************************************************************************
 *  MappingID.hpp
 *  Part of Drile
 *  2010-  Florent Berthaut
 *  hitmuri.net 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _MAPPING_ID_H
#define _MAPPING_ID_H

#include <iostream>
#include <cstring>
#include <sstream>
#include <cmath>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <map>

#include "../input/InputEvent.hpp"

class Mapping;

struct MappingID {
    MappingID(){};
    MappingID(INPUT_TYPE type, Mapping* map, unsigned int i) : inputType(type),
                                                                mapping(map),
                                                                id(i) {}
    MappingID(INPUT_TYPE type, Mapping* map, std::string i) : inputType(type),
                                                                mapping(map),
                                                                strId(i) {}
    INPUT_TYPE inputType;
    Mapping* mapping;
    unsigned int id;
    std::string strId;
};



#endif
