/***************************************************************************
 *            HandDevice.hpp
 *            Part of Drile
 *
 *  2010  Tardigrade Inc.
 *  http://tardigrade-inc.com 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _HAND_DEVICE_H
#define _HAND_DEVICE_H

#include <iostream>
#include <cstring>
#include <cmath>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <map>
#include <libxml/parser.h>
#include <libxml/tree.h>

#include "HandGrabVrpn.hpp"
#include "HandTrackingVrpn.hpp"

#include "../Device.hpp"

class HandDevice: public Device
{
    public:
        HandDevice(const int&);
        ~HandDevice();
        void parse(xmlNodePtr);
        void getMappingsIDs(std::vector<MappingID>&);

        void setSelectedWorms(const HAND&, double*);
        void setGrab(const HAND&, const double&);
        void setSpeed(const HAND&, double*);;
        inline void setLocationStable(const HAND& hand, bool stable){ 
                m_locationStable[hand]=stable;}
        inline const bool& getLocationStable(const HAND& hand){
                return m_locationStable[hand];}

    private:

        bool m_locationStable[2];

};



#endif
