/***************************************************************************
 *            HandGrabVrpn.hpp
 *            Part of Drile
 *
 *  2010  Tardigrade Inc.
 *  http://tardigrade-inc.com 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _HAND_FINGERS_VRPN_H
#define _HAND_FINGERS_VRPN_H

#include <iostream>
#include <cstring>
#include <cmath>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <map>
#include <libxml/parser.h>
#include <libxml/tree.h>

#include "../Mapping.hpp"

class HandDevice;

class HandGrabVrpn: public Mapping
{
    public:
        HandGrabVrpn(const int&, const std::string&, const HAND&, HandDevice*);
        ~HandGrabVrpn();

        void process(InputEvent&, std::vector<Event>&, 
                        std::vector<Event>&);

    private:

        HandDevice* m_handDevice;

        int m_duration;
        double m_durationF;
        double m_thresholdMinOpen;
        double m_thresholdMaxClose;

        double *m_bufferClose; //buffer on open/close value
        int m_indexBC;
        double m_sum;
        double m_popBut;

        bool m_closed;


/*
#define SPEED_THRESHOLD 12.0//minimum speed to consider that the hand is not moving
        double FREEZE_THRESHOLD 40.0
*/

};



#endif
