/***************************************************************************
 *            HandTrackingVrpn.hpp
 *            Part of Drile
 *
 *  2010  Tardigrade Inc.
 *  http://tardigrade-inc.com 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _HAND_TRACKING_VRPN_H
#define _HAND_TRACKING_VRPN_H

#include <iostream>
#include <cstring>
#include <cmath>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <map>
#include <libxml/parser.h>
#include <libxml/tree.h>

#include "../Mapping.hpp"

class HandDevice;

class HandTrackingVrpn: public Mapping
{
    public:
        HandTrackingVrpn(const int&, const std::string&, 
                            const HAND&, HandDevice*);
        ~HandTrackingVrpn();

        void process(InputEvent&, std::vector<Event>&, 
                                    std::vector<Event>&);
    
    private:

        HandDevice* m_handDevice;

        double m_posX;
        double m_posY;
        double m_posZ;


        double m_speedThreshold;
        double m_freezeThreshold;

        int m_indexBL;
        int m_duration;
        double m_durationF;

        double *m_bufferLocation[3];
        double m_popLoc[3];
        double m_sum[3];
        double m_var[3];
        double m_previousPosition[3];

        double m_currentSpeed;

};



#endif
