/***************************************************************************
 *            HeadTrackingOscPos.cpp
 *            Part of Drile
 *
 *  2010  Tardigrade Inc.
 *  http://tardigrade-inc.com 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "HeadTrackingOscPos.hpp"
#include "../../input/InputManager.hpp"
#include "../../env/Camera.hpp"

using namespace std;

HeadTrackingOscPos::HeadTrackingOscPos(const int& id, const std::string& param): Mapping(id)
{
    m_ids.push_back(MappingID(INPUT_OSC, this, param));
}

HeadTrackingOscPos::~HeadTrackingOscPos()
{

}

void HeadTrackingOscPos::process(InputEvent& event, 
                                    std::vector<Event>& outputAudioEvents, 
                                    std::vector<Event>& outputEnvEvents) {
    outputEnvEvents.push_back(Event());
    Event& eEv = outputEnvEvents.back();
    eEv.type=EVENT_CAMERA;
    eEv.parameter=CAMERA_HEAD_POS;
    eEv.piivert = m_id;
    eEv.hand = m_hand;
    eEv.values[0]=event.values[0];
    eEv.values[1]=event.values[1];
    eEv.values[2]=event.values[2];
}

