/***************************************************************************
 *            PiivertTrackingVRPN.hpp
 *            Part of Drile
 *
 *  2010  Tardigrade Inc.
 *  http://tardigrade-inc.com 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _PIIVERT_TRACKING_VRPN_H
#define _PIIVERT_TRACKING_VRPN_H

#include <iostream>
#include <cstring>
#include <cmath>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <map>
#include <libxml/parser.h>
#include <libxml/tree.h>

#include "../Mapping.hpp"

class PiivertTrackingVRPN: public Mapping
{
    public:
        PiivertTrackingVRPN(const int&, const std::string&, const HAND&);
        ~PiivertTrackingVRPN();

        void process(InputEvent&, std::vector<Event>&, std::vector<Event>&);
    
    private:

        double m_posX;
        double m_posY;
        double m_posZ;

        static const double MAX_POS_X=3;
        static const double MIN_POS_X=-3;
        static const double MAX_POS_Y=3;
        static const double MIN_POS_Y=-3;
        static const double MAX_POS_Z=3;
        static const double MIN_POS_Z=-3;
};



#endif
