/***************************************************************************
 *            PiivertVibroOsc.hpp
 *            Part of Drile
 *
 *  2010  Tardigrade Inc.
 *  http://tardigrade-inc.com 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _PIIVERT_VIBRO_OSC_H
#define _PIIVERT_VIBRO_OSC_H

#include <iostream>
#include <cstring>
#include <cmath>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <map>
#include <libxml/parser.h>
#include <libxml/tree.h>

#include "../Mapping.hpp"
#include "../../input/oscPack/osc/OscOutboundPacketStream.h"
#include "../../input/oscPack/ip/UdpSocket.h"
#include "../../input/oscPack/ip/IpEndpointName.h"
#include "../../input/oscPack/osc/OscReceivedElements.h"
#include "../../input/oscPack/ip/UdpSocket.h"
#include "../../input/oscPack/osc/OscPacketListener.h"

#define IP_MTU_SIZE 1536

class PiivertVibroOsc: public Mapping
{
    public:
        PiivertVibroOsc(const int&, const std::string&);
        ~PiivertVibroOsc();

        void processOutput(const OutputEvent&);

        void process(InputEvent&, std::vector<Event>&, std::vector<Event>&);
    private:

        UdpTransmitSocket* m_socket;

        std::string m_adress;
        int m_port;
};



#endif
