/***************************************************************************
 *  Ghostable.hpp
 *  Part of Drile
 *  2010-  Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _GHOSTABLE_H
#define _GHOSTABLE_H

#include <OpenSG/OSGSimpleGeometry.h>
#include <OpenSG/OSGComponentTransform.h>

class Worm;

class Ghostable {
    public:
        Ghostable();
        virtual ~Ghostable();

        virtual OSG::NodeRecPtr getNode()=0;
        virtual OSG::NodeRecPtr getCollisionNode()=0;
        virtual OSG::ComponentTransformRecPtr getTrans()=0;
        virtual Ghostable* createGhost()=0;
        virtual void testCollisionWithWorm(Worm* worm){};

        inline void setLiving(Ghostable* living){m_living=living;}
        virtual void deleteAllGhosts();
        inline unsigned int getNbGhosts(){return m_ghosts.size();}

    protected:
        Ghostable* m_living;
        std::vector<Ghostable*> m_ghosts;
};



#endif
