/***************************************************************************
 *  LoopWorm.hpp
 *  Part of Drile
 *  2010- Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _LOOP_WORM_H
#define _LOOP_WORM_H

#include <OpenSG/OSGSceneFileHandler.h>
#include <OpenSG/OSGGeoFunctions.h>

#include "Worm.hpp"

class LoopWorm: public Worm {
    public:
        LoopWorm(const int&);
        ~LoopWorm();
        void parse(xmlNodePtr);
        void update(std::vector<Event>& outputEvents);

        void setRotationOffset(const double&);

        virtual void setParameter(const Worm::WORM_PARAMETER&, double*, 
                                    unsigned int, 
                                    bool valueFromAudio=false);
        void setParameter(const std::string&, const std::string&);

        Ghostable* createGhost();
        
    private:
        OSG::ComponentTransformRecPtr m_offsetTrans;
        OSG::ComponentTransformRecPtr m_wheelTrans;
        OSG::GeometryRecPtr m_offsetGeo;
        OSG::NodeRecPtr m_offsetNode;
        OSG::NodeRecPtr m_offsetTransNode;

        OSG::ComponentTransformRecPtr m_scaleTrans;

        double m_rotationSpeed;
        double m_rotation;

        std::string m_geomString;

        OSG::GeometryRecPtr createLoopGeo(const double&);
};



#endif
