/***************************************************************************
 *            Reconstruct.hpp
 *            Part of Drile
 *
 *  2010- Florent Berthaut
 *  http://hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#ifndef _Reconstruct_H
#define _Reconstruct_H

#include <iostream>
#include <cstring>
#include <cmath>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <map>

#include <OpenSG/OSGSimpleGeometry.h>
#include <OpenSG/OSGGeometry.h>
#include <OpenSG/OSGComponentTransform.h>
#include <OpenSG/OSGMaterialGroup.h>
#include <OpenSG/OSGSceneFileHandler.h>
#include <OpenSG/OSGSimpleTexturedMaterial.h>
#include <OpenSG/OSGImage.h>
#include <OpenSG/OSGTextureBackground.h>

#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"

#include "Worm.hpp"


class Reconstruct {
    public:
        Reconstruct(int);
        ~Reconstruct();

        void parse(xmlNodePtr);

        void load();
        void update();

        //inline OSG::NodeRefPtr getNode(){return m_reconstructTransNode;}
        inline OSG::TextureBackgroundRefPtr getBackground(){return m_back;}

    private:

        std::string m_name;

        cv::VideoCapture m_cap;

        OSG::ImageRefPtr m_image;
        OSG::TextureObjChunkRefPtr m_texObj;
        OSG::TextureBackgroundRefPtr m_back;

        OSG::Vec3f m_position;
        OSG::Vec3f m_rotation;
        OSG::Vec3f m_scale;
        unsigned int m_device;

        unsigned int m_width;
        unsigned int m_height;
        int m_cam;

        
};



#endif
