/***************************************************************************
 *  SyncWorm.hpp
 *  Part of Drile
 *  2010- Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _SYNC_WORM_H
#define _SYNC_WORM_H

#include "Worm.hpp"

class SyncWorm: public Worm {
    public:
        SyncWorm(const int&);
        ~SyncWorm();
        void parse(xmlNodePtr);

        virtual void setParameter(const WORM_PARAMETER&, double*, unsigned int, 
                                    bool valueFromAudio=false);
        void setParameter(const std::string&, const std::string&);
    
        virtual void addChild(Worm*);
        virtual void removeChild(Worm*);

//        virtual void setScattering(const double&);

//        bool testCollisionWithVolume(OSG::BoxVolume&);
        
        Ghostable* createGhost();

    private:

        std::vector<unsigned int> m_modifiedChildrenControls;

        double m_loopWormLayersNb;
};



#endif
