/***************************************************************************
 *  GenericInput.hpp
 *  Part of Drile
 *  2010  Tardigrade Inc.
 *  http://tardigrade-inc.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef GENERIC_INPUT_H
#define GENERIC_INPUT_H

#include <iostream>
#include <math.h>
#include <vector>
#include <exception>

#include "InputEvent.hpp"

class GenericInput
{
    public:
        GenericInput();
        virtual ~GenericInput();
        virtual void init()=0;
        virtual void start()=0;
        virtual void stop()=0;
        virtual void process(std::vector<InputEvent>&)=0;

    protected:

        //pthread_t m_thread;

};






#endif 
