/***************************************************************************
 *  InputEvent.hpp
 *  Part of Drile
 *  2010-  Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _INPUT_EVENT_H
#define _INPUT_EVENT_H

#include <iostream>
#include <cstring>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <map>

enum INPUT_TYPE{INPUT_OSC, INPUT_VRPN_TRACKER, INPUT_VRPN_BUTTON, 
                INPUT_MICE, INPUT_MIDI_CC, INPUT_MIDI_NOTE, INPUT_SERIAL, 
                INPUT_TYPES_NB};

struct InputEvent {
    INPUT_TYPE type;
    unsigned int id;
    std::string strId;
    int device;
    int parameter;
    std::string strParameter;
    static const unsigned int nbValues=32;
    double values[nbValues];
};


#endif
