/***************************************************************************
 *  MiceInput.hpp
 *  Part of Drile
 *  2010-  Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef MICE_INPUT_H
#define MICE_INPUT_H

#include <fstream>
#include <sstream>
#include <iostream>
#include <vector>
#include <map>
#include <pthread.h>
#include <string>
#include <sys/time.h>

#include "mm/manymouse.h"
#include "GenericInput.hpp"

enum MOUSE_PARAMETER{MOUSE_X, MOUSE_Y, MOUSE_SCROLL, MOUSE_BUTTONS};

class MiceInput: public GenericInput {    
    public:
        MiceInput();
        ~MiceInput();

        void init();
        void start();
        void stop();

        void process(std::vector<InputEvent>&);

        inline int getNbMice(){return m_nbMice;}

    private:

        int m_nbMice;
        std::vector< std::vector<long> > m_miceFlamTimes;
        static const float MAX_FLAM_TIME=1000.0;
};

#endif

