/***************************************************************************
 *  MidiInput.hpp
 *  Part of Drile
 *  2010-  Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef MIDI_INPUT_H
#define MIDI_INPUT_H

#include <alsa/asoundlib.h>
#include <iostream>
#include <math.h>

#include "GenericInput.hpp"

class MidiInput: public GenericInput
{
    public:
        MidiInput();
        ~MidiInput();
        void init();
        void start();
        void stop();

        void process(std::vector<InputEvent>&);

    private:    

        snd_seq_t *m_seqHandle;
        int m_npfd;
        struct pollfd *m_pfd;
        int m_inputPort;
        int m_priority;
};


#endif 
