/***************************************************************************
 *  OscInput.hpp
 *  Part of Drile
 *  2010  Tardigrade Inc.
 *  http://tardigrade-inc.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef OSC_INPUT_H
#define OSC_INPUT_H


#include <iostream>
#include <math.h>
#include <vector>
#include "oscPack/osc/OscOutboundPacketStream.h"
#include "oscPack/ip/UdpSocket.h"
#include "oscPack/ip/IpEndpointName.h"
#include "oscPack/osc/OscReceivedElements.h"
#include "oscPack/ip/UdpSocket.h"
#include "oscPack/osc/OscPacketListener.h"

#include "GenericInput.hpp"

#define IP_MTU_SIZE 1536

struct InputEvent;

class OscProcess : public osc::OscPacketListener
{
    public:
        OscProcess();
        ~OscProcess();
        void ProcessMessage( const osc::ReceivedMessage&, const IpEndpointName&);
        void sendMessage(char*,int,float);
        void receiveMessages();
    private:    
        osc::OutboundPacketStream *m_packetStream;
        int m_inputPort;
};

class OscInput: public GenericInput
{
    public:
        OscInput();
        ~OscInput();
        void init();
        void start();
        void stop();

        void process(std::vector<InputEvent>&);

        inline void setInputPort(int port){m_inputPort=port;}

        void sendMessage(std::string,std::string,std::vector<float>);

        friend void* oscThreadFunction(void*);

    private:


        OscProcess m_oscProcess;
        int m_inputPort;
        UdpListeningReceiveSocket *m_socket;
};






#endif 
