/***************************************************************************
 *  SerialInput.hpp
 *  Part of Drile
 *  2010- Florent Berthaut
 *  hitmuri.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef WITH_SERIAL

#include <fstream>
#include <sstream>
#include <iostream>
#include <vector>
#include <map>
#include <pthread.h>
#include <string>
#include <sys/time.h>

#include <SerialStream.h>
#include "GenericInput.hpp"

#ifndef SERIAL_INPUT_H
#define SERIAL_INPUT_H

class SerialInput: public GenericInput {    
    public:
        SerialInput();
        ~SerialInput();

        void init();
        void start();
        void stop();

        void process(std::vector<InputEvent>&);

        int addDevice(const std::string&, const int&);

    private:
        int portInit(const std::string&, const int&);
        bool portReadTwoInts(const int&, int&, int&);

    private:
        std::vector<int> m_serialFDs;
        LibSerial::SerialStream m_serialStreams[10];
        LibSerial::SerialStream m_serialStream;
        int m_nbSerialStreams;
        std::vector<std::string> m_devicesNames;
        std::vector<int> m_devicesBauds;
};

#endif
#endif

