/***************************************************************************
 *            RenderWidget.cpp
 *
 *  2006  Florent Berthaut
 *  florentberthaut@no-log.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "RenderWidget.hpp"

#include "../env/EnvManager.hpp"
#include "Fl/gl.h"

using namespace std;


RenderWidget::RenderWidget(int x, int y, int w,int h,const char* titre):Fl_Gl_Window(x,y,w,h,titre)
{
	mode(FL_RGB|FL_DOUBLE|FL_ALPHA|FL_DEPTH);
	box(FL_DOWN_BOX);
	cursor(FL_CURSOR_NONE);
	end();
}

RenderWidget::~RenderWidget()
{
}

void RenderWidget::draw()
{
	EnvManager *envManager = EnvManager::getInstance();
	if(!valid()) {
		envManager->initWindows();
		valid(1);
	}

	glClearColor(0, 0, 0, 0);
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

//	Drile *drile=Drile::getInstance();		
	//update Drile 
	//simply update the cameras in the EnvManager
	envManager->updateWindows();

	usleep(1000);
}

