/***************************************************************************
 *            StartWindow.cpp
 *
 *  part of Drile
 *  2010  Tardigrade inc.
 *  http://tardigrade-inc.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <iostream>
#include <math.h>
#include <FL/x.H>

#include "StartWindow.hpp"
#include "../env/EnvManager.hpp"


using namespace std;


StartWindow::StartWindow(int w,int h,const char* titre): Fl_Double_Window(w,h,titre)
{
	//default theme
	Fl::set_color(FL_BACKGROUND_COLOR,0,0,0);
	Fl::set_color(FL_BACKGROUND2_COLOR,80,80,80);
	Fl::set_color(FL_FOREGROUND_COLOR,255,255,255);
	Fl::set_color(FL_INACTIVE_COLOR,40,40,40);
	Fl::set_color(FL_SELECTION_COLOR,0,0,255);


	this->color(FL_BACKGROUND2_COLOR);

	m_mainButton = new Fl_Button(15,30,80,40,"MAIN");
	m_mainButton->box(FL_FLAT_BOX);
	m_mainButton->type(FL_TOGGLE_BUTTON);
	m_mainButton->selection_color(FL_SELECTION_COLOR);
	m_mainButton->clear_visible_focus();
	m_mainButton->callback(statButtons,this);

	m_displayButton = new Fl_Button(105,30,80,40,"DISPLAY");
	m_displayButton->box(FL_FLAT_BOX);
	m_displayButton->type(FL_TOGGLE_BUTTON);
	m_displayButton->selection_color(FL_SELECTION_COLOR);
	m_displayButton->clear_visible_focus();
	m_displayButton->callback(statButtons,this);
}


StartWindow::~StartWindow()
{
}

void StartWindow::cbButtons(Fl_Widget* w)
{
	if(m_mainButton->contains(w)) {
		m_application=0;
	}
	else {
		m_application=1;
	}

	this->hide();
}
