/***************************************************************************
 *            StartWindow.h
 *
 *  2006  Florent Berthaut
 *  florentberthaut@no-log.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
 
#ifndef _START_WINDOW_H
#define _START_WINDOW_H

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Gl_Window.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Menu_Item.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Text_Display.H>
#include <FL/Fl_Text_Buffer.H>
#include <FL/Fl_File_Chooser.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Toggle_Button.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Value_Input.H>
#include <FL/Fl_Float_Input.H>
#include <FL/Fl_Counter.H>
#include <FL/Fl_Dial.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Shared_Image.H>
#include <FL/Fl_Hold_Browser.H>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <locale>
#include <ctype.h>

#include "RenderWidget.hpp"
#include "TardiFileBrowser.hpp"


class StartWindow : public Fl_Double_Window 
{
  public:
		StartWindow(int ,int ,const char*);
		~StartWindow();
		
		//menu callback
		static void statButtons(Fl_Widget* w,void* f){StartWindow *tmpf = static_cast<StartWindow *>(f);tmpf->cbButtons(w);}	
		void cbButtons(Fl_Widget*);

		int getApplication(){return m_application;}

  private:
		int m_application;

		Fl_Button* m_displayButton;
		Fl_Button* m_mainButton;
};

#endif 
