/***************************************************************************
 *            RingBuffer.hpp
 *  	      Part of Drile
 *
 *  2010  Tardigrade Inc.
 *  http://tardigrade-inc.com 
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _RingBuffer_H
#define _RingBuffer_H

#include <iostream>
#include <cstring>
#include <sstream>
#include <cmath>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <vector>
#include <cassert>
#include <map>
#include <jack/ringbuffer.h>

#include "../Event.hpp"

class RingBuffer
{
	public:
		RingBuffer(size_t);
		~RingBuffer();

		void addEvent(const Event&);
		bool eventsAvailable();	
		void getEvent(Event&);

	protected:
		
		size_t m_eventSize;
		jack_ringbuffer_t*  m_ringBuffer;
};



#endif
